#ifndef _CONFIG_H
#define _CONFIG_H

#include <string.h>

/* Default config */
#ifndef ROOT
	#define ROOT "www"
#endif

/* HTML */
#ifndef CSS
	#define CSS "style.css"
#endif

#ifndef LOGO
	#define LOGO "logo.png"
#endif

#ifndef DESC
	#define DESC "8img"
#endif

#ifndef TITLE
	#define TITLE "/ img"
#endif

#ifndef POSTS_AT_PAGE
	#define POST_AT_PAGE 5
#endif

/* RSS */
#ifndef LINK
	#define LINK "https://nlight.tilde.team/img"
#endif

#ifndef XML_FILE
	#define XML_FILE "index.xml"
#endif

#ifndef LANGUAGE
	#define LANGUAGE "en-US"
#endif

#ifndef MAX_POSTS
	#define MAX_POSTS 25
#endif

#ifndef DATE_FORMAT
	#define DATE_FORMAT "%a, %d %h %Y %H:%M:%S %z"
#endif

struct CONFIG {
	char allocated;

	char *prog_name;

	char *root;
	char root_alloc;

	/* HTML */
	char *css;
	char css_alloc;

	char *logo;
	char logo_alloc;

	char *desc;
	char desc_alloc;

	char *title;
	char title_alloc;

	size_t posts_at_page;

	/* RSS */
	char *link;
	char link_alloc;

	char *xml_file;
	char xml_file_alloc;

	char *language;
	char language_alloc;

	size_t max_posts;

	/* Date format */
	char *date_fmt;
	char date_fmt_alloc;
};

void free_cfg(struct CONFIG *cfg);
int parse_config(struct CONFIG *cfg, const char *cfg_path);

#endif
